---
title: Navigator.msLaunchUri()
slug: Web/API/Navigator/msLaunchUri
tags:
  - API
  - 'API:Microsoft Extensions'
  - MSLaunchUri
  - Method
  - Non-standard
  - Reference
---
<div>{{APIRef("Microsoft Extensions")}}{{Non-standard_header}}</div>

<p>The <strong><code>msLaunchUri()</code></strong> method is a Microsoft extension to the {{DOMxRef("Navigator")}} interface, which starts a service or app, such as an email client, that handles a given protocol. The Uniform Resource Identifier (URI) contains the protocol for the default service or app, such as <code>mailto://test@contoso.com</code>.</p>

<p>This proprietary method is specific to Internet Explorer, and Microsoft Edge versions 18 and lower.</p>

<h2 id="Syntax">Syntax</h2>

<pre>navigator.msLaunchUri(<em>uri</em>, <em>successCallback</em>, <em>noHandlerCallback</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>uri</code></dt>
 <dd>A {{domxref("DOMString")}} specifying the URL containing including the protocol of the document or resource to be displayed.</dd>
</dl>

<dl>
 <dt><code>successCallback</code>{{Optional_Inline}}</dt>
 <dd>A function matching the signature of {{DOMxRef("MSLaunchUriCallback")}} to be executed if the protocol handler is present.</dd>
</dl>

<dl>
 <dt><code>noHandlerCallback</code>{{Optional_Inline}}</dt>
 <dd>A function matching {{DOMxRef("MSLaunchUriCallback")}} to be executed if the protocol handler is <em>not</em> present.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p><code>undefined</code>.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>If a default protocol handler is available on the system that matches the URI, the <code>successCallback</code> is invoked, otherwise, the <code>noHandlerCallback</code> is called.</p>

<p>To help protect a user's privacy, Windows displays a prompt for the user to allow the service or app to be launched. The user can choose to not see the prompt after the first instance for a particular protocol and automatically open the app or service without a user intervention. The <code>msLaunchUri()</code> method does not support HTTP, Secure Hypertext Transfer Protocol (HTTPS), File Transfer Protocol (FTP), file, res, JavaScript, or Microsoft Visual Basic Scripting Edition (VBScript) protocols.</p>

<p>If the user's system does not have a program registered to handle a specific protocol, and a <code>noHandlerCallback</code> is provided, Windows Internet Explorer will invoke the <code>noHandlerCallback</code>. This enables developers to provide a custom fallback experience for the user. If a handler doesn't exist, and the developer doesn't provide a <code>noHandlerCallback</code>, then Internet Explorer displays a dialog that asks the user if they want to allow the action. If the user allows it, the user is then prompted to look in the Windows Store for an app to handle the protocol. If multiple programs are registered on the system for the given protocol and no default has been chosen, Windows prompts the user to choose one.</p>

<h2 id="See_Also">See also</h2>

<ul>
 <li>{{DOMxRef("MSLaunchUriCallback")}}</li>
 <li><a href="/en-US/docs/Web/API/Microsoft_API_extensions">Microsoft API extensions </a></li>
</ul>
